package com.hammurapi.eventbus.tests.familyties.rules;

import java.util.HashSet;
import java.util.Set;

import com.hammurapi.eventbus.AbstractEventBus;
import com.hammurapi.eventbus.AbstractEventBus.Handle;
import com.hammurapi.eventbus.AbstractEventHandler;
import com.hammurapi.eventbus.EventDispatchContext;
import com.hammurapi.eventbus.EventHandler;
import com.hammurapi.eventbus.JavaBinder;
import com.hammurapi.extract.Predicate;

/**
 * Binds handler class com.hammurapi.eventbus.tests.familyties.rules.SpouseRules to event bus com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus
 */
public class SpouseRulesJavaBinder implements JavaBinder<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus, com.hammurapi.eventbus.tests.familyties.rules.SpouseRules> {

	@Override
	public Set<java.lang.Long> bind(com.hammurapi.eventbus.tests.familyties.rules.SpouseRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		Set<java.lang.Long> ret = new HashSet<java.lang.Long>();
		
				ret.add(inferSpouse(instance, bus));
				ret.add(inferHusband(instance, bus));
				ret.add(inferWife(instance, bus));
				
		return ret;
	}
	
		
	private java.lang.Long inferSpouse(final com.hammurapi.eventbus.tests.familyties.rules.SpouseRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[1];
		
				
		predicates[0] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Spouse.class);
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(1, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.Spouse toPost  =  instance.inferSpouse(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Spouse) events[0]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.Spouse com.hammurapi.eventbus.tests.familyties.rules.SpouseRules.inferSpouse(com.hammurapi.eventbus.tests.familyties.model.Spouse), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
	private java.lang.Long inferHusband(final com.hammurapi.eventbus.tests.familyties.rules.SpouseRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[1];
		
				
		predicates[0] = new com.hammurapi.extract.And(0, null, new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Spouse.class), new Predicate2(null), new com.hammurapi.extract.Not(new com.hammurapi.extract.InstanceOfPredicate(new Extractor14(null), com.hammurapi.eventbus.tests.familyties.model.Husband.class)));
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(1, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.Husband toPost  =  instance.inferHusband(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Spouse) events[0]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.Husband com.hammurapi.eventbus.tests.familyties.rules.SpouseRules.inferHusband(com.hammurapi.eventbus.tests.familyties.model.Spouse), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
	private java.lang.Long inferWife(final com.hammurapi.eventbus.tests.familyties.rules.SpouseRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[1];
		
				
		predicates[0] = new com.hammurapi.extract.And(0, null, new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Spouse.class), new com.hammurapi.extract.Not(new Predicate2(null)), new com.hammurapi.extract.Not(new com.hammurapi.extract.InstanceOfPredicate(new Extractor14(null), com.hammurapi.eventbus.tests.familyties.model.Wife.class)));
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(1, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.Wife toPost  =  instance.inferWife(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Spouse) events[0]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.Wife com.hammurapi.eventbus.tests.familyties.rules.SpouseRules.inferWife(com.hammurapi.eventbus.tests.familyties.model.Spouse), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
}
