package com.hammurapi.eventbus.tests.familyties;

import java.util.concurrent.locks.ReadWriteLock;

import com.hammurapi.eventbus.AbstractEventBus;
import com.hammurapi.eventbus.HandleExtractor;
import com.hammurapi.extract.Predicate;
import com.hammurapi.store.AbstractStore;
import com.hammurapi.store.DeputyStore;
import com.hammurapi.store.LiveView;
import com.hammurapi.store.UnmodifiableStore;
import com.hammurapi.store.local.LocalStoreBase;

/**
 * Implementation of event store.
 */
public class FamilyTiesEventStoreImpl extends LocalStoreBase<AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative,java.lang.Integer,com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules,Long>, com.hammurapi.eventbus.tests.familyties.model.Relative, FamilyTiesEventStore> implements FamilyTiesEventStore {

	/**
	 * Config class with bound generic parameters. 
	 * @author Pavel Vlasov
	 *
	 */
	public static class Config extends LocalStoreBase.Config<AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative,java.lang.Integer,com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules,Long>, com.hammurapi.eventbus.tests.familyties.model.Relative, FamilyTiesEventStore> {
		
		public Config() {
			setPrimaryKeyExtractor(new HandleExtractor<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, Long, AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative,java.lang.Integer,com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules,Long>, FamilyTiesEventStore>());
		}
	}

	public FamilyTiesEventStoreImpl(Config config) {
		super(config);
	}
	
	protected static class FamilyTiesEventDeputyStore extends DeputyStore<AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative,java.lang.Integer,com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules,Long>, com.hammurapi.eventbus.tests.familyties.model.Relative, FamilyTiesEventStore> implements FamilyTiesEventStore {

		public FamilyTiesEventDeputyStore(
				AbstractStore<AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, Long>, com.hammurapi.eventbus.tests.familyties.model.Relative, FamilyTiesEventStore> master,
				ReadWriteLock masterLock) {
			super(master, masterLock);
		}

		@Override
		protected FamilyTiesEventStore createDeputy() {
			return new FamilyTiesEventDeputyStore(this, createMasterLock());
		}
		
		@Override
		public FamilyTiesEventStore createUnmodifiableFacade() {
			return new FamilyTiesEventUnmodifiableStore(this);
		}

		@Override
		protected FamilyTiesEventStore createLiveView(Predicate<AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative,java.lang.Integer,com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules,Long>, FamilyTiesEventStore> selector) {
			return new FamilyTiesEventLiveView(this, selector);
		}
		
	}
	
	protected static class FamilyTiesEventUnmodifiableStore extends UnmodifiableStore<AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative,java.lang.Integer,com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules,Long>, com.hammurapi.eventbus.tests.familyties.model.Relative, FamilyTiesEventStore> implements FamilyTiesEventStore {

		public FamilyTiesEventUnmodifiableStore(FamilyTiesEventStore master) {
			super(master);
		}
		
	}
	
	protected static class FamilyTiesEventLiveView extends LiveView<AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative,java.lang.Integer,com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules,Long>, com.hammurapi.eventbus.tests.familyties.model.Relative, FamilyTiesEventStore> implements FamilyTiesEventStore {
		
		public FamilyTiesEventLiveView(
				FamilyTiesEventStore master,
				Predicate<AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, Long>, FamilyTiesEventStore> selector) {
			super(master, selector);
		}

		@Override
		public FamilyTiesEventStore createUnmodifiableFacade() {
			return new FamilyTiesEventUnmodifiableStore(this);
		}
		
	}

	@Override
	protected FamilyTiesEventStore createDeputy() {
		return new FamilyTiesEventDeputyStore(this, createMasterLock());
	}
	
	@Override
	public FamilyTiesEventStore createUnmodifiableFacade() {
		return new FamilyTiesEventUnmodifiableStore(this);
	}

	@Override
	protected FamilyTiesEventStore createLiveView(Predicate<AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative,java.lang.Integer,com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules,Long>, FamilyTiesEventStore> selector) {
		return new FamilyTiesEventLiveView(this, selector);
	}

}
